﻿using Infragistics.Web.UI.GridControls;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            InicializarWebDataGrid();
            CargarGrid();
        }
    }


    protected void wdgEspecificacionxFila_RowAdding(object sender, Infragistics.Web.UI.GridControls.RowAddingEventArgs e)
    {
        try
        {
            if (ValidaCamposCeldasVaciasDetalleEmpaque(e.Values))
            {
                DataSet dsPatronEmpaqueActual = Session["PatronEmpaque"] as DataSet;
                int numeroFila = 0;
                int codigo = 0;

                if (dsPatronEmpaqueActual != null
                    && dsPatronEmpaqueActual.Tables.Count > 0
                    && dsPatronEmpaqueActual.Tables[0].Rows.Count >= 1)
                {
                    codigo = Convert.ToInt32(dsPatronEmpaqueActual.Tables[0].Rows[dsPatronEmpaqueActual.Tables[0].Rows.Count - 1]["Codigo"]);
                    numeroFila = Convert.ToInt32(dsPatronEmpaqueActual.Tables[0].Rows[dsPatronEmpaqueActual.Tables[0].Rows.Count - 1]["NumeroFila"]);
                }

                codigo += 1;
                numeroFila += 1;

                DataRow drNuevaFila = dsPatronEmpaqueActual.Tables[0].NewRow();
                drNuevaFila["Codigo"] = codigo;
                drNuevaFila["NumeroFila"] = numeroFila;
                drNuevaFila["Nombre"] = Convert.ToString(e.Values["Nombre"]);
                drNuevaFila["Apellido"] = Convert.ToString(e.Values["Apellido"]);

                dsPatronEmpaqueActual.Tables[0].Rows.Add(drNuevaFila);
                dsPatronEmpaqueActual.AcceptChanges();

                Session["PatronEmpaque"] = dsPatronEmpaqueActual;

            }
            else
            {
                e.Cancel = true;
            }
        }
        catch (Exception ex)
        {
           
        }
        finally
        {
            CargarGrid();
        }
    }


    protected void wdgEspecificacionxFila_RowUpdating(object sender, Infragistics.Web.UI.GridControls.RowUpdatingEventArgs e)
    {
        try
        {
            if (ValidaCamposCeldasVaciasDetalleEmpaque(e.Values))
            {

                DataSet dsPatronEmpaqueActual = Session["PatronEmpaque"] as DataSet;
                int numeroFila = 0;
                int codigo = 0;

                if (dsPatronEmpaqueActual != null
                    && dsPatronEmpaqueActual.Tables.Count > 0
                    && dsPatronEmpaqueActual.Tables[0].Rows.Count >= 1)
                {
                    codigo = Convert.ToInt32(dsPatronEmpaqueActual.Tables[0].Rows[dsPatronEmpaqueActual.Tables[0].Rows.Count - 1]["Codigo"]);
                    numeroFila = Convert.ToInt32(dsPatronEmpaqueActual.Tables[0].Rows[dsPatronEmpaqueActual.Tables[0].Rows.Count - 1]["NumeroFila"]);
                }

                DataRow drFilaActualizar = dsPatronEmpaqueActual.Tables[0].Rows.Find(new object[] { codigo, numeroFila });
                drFilaActualizar["Nombre"] = Convert.ToString(e.Values["Nombre"]);
                drFilaActualizar["Apellido"] = Convert.ToString(e.Values["Apellido"]);
               
                dsPatronEmpaqueActual.AcceptChanges();

                Session["PatronEmpaque"] = dsPatronEmpaqueActual;
                
            }
            else
            {
                e.Cancel = true;
            }
        }
        catch (Exception ex)
        {
            
        }
    }


    protected void wdgEspecificacionxFila_RowsDeleting(object sender, Infragistics.Web.UI.GridControls.RowDeletingEventArgs e)
    {
        try
        {
            if (e.Row != null)
            {
                DataSet dsNuevoPatron = LlenarCambiosDefinicion(Convert.ToInt32(e.Row.Items.FindItemByKey("NumeroFila").Value));
                Session["PatronEmpaque"] = dsNuevoPatron;
            }
        }
        catch (Exception ex)
        {
            
        }
        finally
        {
            CargarGrid();
        }
    }


    public DataSet LlenarCambiosDefinicion(int NumeroFilaEliminada)
    {
        DataSet dsDetalleEmpaque = new DataSet();
        dsDetalleEmpaque.Tables.Add(CrearEstructuraTabla()); 

        foreach (GridRecord fila in wdgEspecificacionxFila.Rows)
        {
            if (Convert.ToInt32(fila.Items.FindItemByKey("NumeroFila").Value) < NumeroFilaEliminada)
            {
                dsDetalleEmpaque.Tables[0].Rows.Add(
                    new object[] { Convert.ToInt32(fila.Items.FindItemByKey("Codigo").Value)
                                   , Convert.ToInt32(fila.Items.FindItemByKey("NumeroFila").Value)
                                   , Convert.ToString(fila.Items.FindItemByKey("Nombre").Value)
                                   , Convert.ToString(fila.Items.FindItemByKey("Apellido").Value)});
            }
            else
            {
                if (Convert.ToInt16(fila.Items.FindItemByKey("NumeroFila").Value) != NumeroFilaEliminada)
                {
                    dsDetalleEmpaque.Tables[0].Rows.Add(
                        new object[] { Convert.ToInt32(fila.Items.FindItemByKey("Codigo").Value) 
                            , Convert.ToInt32(fila.Items.FindItemByKey("NumeroFila").Value) -1
                            , Convert.ToString(fila.Items.FindItemByKey("Nombre").Value)
                            , Convert.ToString(fila.Items.FindItemByKey("Apellido").Value)});
                }
            }
        }
        return dsDetalleEmpaque;
    }

    private DataTable CrearEstructuraTabla()
    {
        DataTable dtPatron = new DataTable();
        DataColumn dcColumna = new DataColumn("Codigo", System.Type.GetType("System.Int32"));
        dtPatron.Columns.Add(dcColumna);
        dcColumna = new DataColumn("NumeroFila", System.Type.GetType("System.Int32"));
        dtPatron.Columns.Add(dcColumna);
        dcColumna = new DataColumn("Nombre", System.Type.GetType("System.String"));
        dtPatron.Columns.Add(dcColumna);
        dcColumna = new DataColumn("Apellido", System.Type.GetType("System.String"));
        dtPatron.Columns.Add(dcColumna);

        return dtPatron;
    }


    private DataSet CrearEstructuraDataSet()
    {
        DataSet dsPatronEmpaque = new DataSet();
        DataTable dtPatron = CrearEstructuraTabla();
        dsPatronEmpaque.Tables.Add(dtPatron);

        DataRow drNuevaFila = null;
        int codigo = 1234;
        string[] nombres = {"Juan","Andres","Carlos","Mario","Alberto"};
        string[] apellidos = { "Rodriguez","Sanchez","Arias","Alvarado","Barquero"};

        for (int i = 0; i < 5; i++)
        {
            drNuevaFila = dsPatronEmpaque.Tables[0].NewRow();
            drNuevaFila["Codigo"] = codigo + i;
            drNuevaFila["NumeroFila"] = i+1;
            drNuevaFila["Nombre"] = nombres[i];
            drNuevaFila["Apellido"] = apellidos[i];

            dsPatronEmpaque.Tables[0].Rows.Add(drNuevaFila);
        }

        dsPatronEmpaque.Tables[0].PrimaryKey = new DataColumn[] { dsPatronEmpaque.Tables[0].Columns["Codigo"], dsPatronEmpaque.Tables[0].Columns["NumeroFila"] };
        dsPatronEmpaque.AcceptChanges();

        return dsPatronEmpaque;
    }


    private void CargarGrid()
    {
        DataSet dsPatronEmpaque = null;

        if (Session["PatronEmpaque"] == null)
        {
            dsPatronEmpaque = CrearEstructuraDataSet();
            Session["PatronEmpaque"] = dsPatronEmpaque;
        }
        //else
        //{ 
        //    dsPatronEmpaque = Session["PatronEmpaque"] as DataSet;
        //}

        wdgEspecificacionxFila.DataSource = Session["PatronEmpaque"];
        //wdgEspecificacionxFila.DataBind();

        
    }


    private bool ValidaCamposCeldasVaciasDetalleEmpaque(Hashtable fila)
    {
        string nombreColumna = String.Empty;

        //valida que las celdas del grid no se encuentren vacías
        if (fila["Nombre"] == null && String.IsNullOrEmpty(nombreColumna))
        {
            nombreColumna = "Nombre";
        }
        else if (fila["Apellido"] == null && String.IsNullOrEmpty(nombreColumna))
        {
            nombreColumna = "Apellido";
        }

        if (!String.IsNullOrEmpty(nombreColumna))
        {
            return false;
        }

        return true;
    }


    private bool ValidaCamposCeldasVaciasDetalleEmpaque(GridRecord fila)
    {
        foreach (GridRecordItem cell in fila.Items)
        {
            if (cell.Value == null && !cell.Column.Header.FieldKey.Contains("Eliminar"))
            {
                return false;
            }
        }

        return true;
    }

    private void InicializarWebDataGrid()
    {
        try
        {
            #region Creación de Columnas
            
            BoundDataField field = WebDataGridUtilitarios.CrearColumna("Codigo"
                , "Código"
                , true
                , 10
                , 0
                , "AlignLeft");
            field.DataType = "System.Int32";
            this.wdgEspecificacionxFila.Columns.Add(field);
            
            field = WebDataGridUtilitarios.CrearColumna("NumeroFila"
               , "Número Fila"
               , false
               , 100
               , 1
               , "AlignLeft");
            field.DataType = "System.Int32";
            this.wdgEspecificacionxFila.Columns.Add(field);

            field = WebDataGridUtilitarios.CrearColumna("Nombre"
              , "Nombre"
              , false
              , 100
              , 2
              , "AlignLeft");
            field.DataType = "System.String";
            this.wdgEspecificacionxFila.Columns.Add(field);

            field = WebDataGridUtilitarios.CrearColumna("Apellido"
               , "Apellido"
               , false
               , 100
               , 3
               , "AlignLeft");
            field.DataType = "System.String";
            this.wdgEspecificacionxFila.Columns.Add(field);

            #endregion

            #region Creación de Columnas editables
            EditingColumnSetting configuracionColumnaNumeroFila = WebDataGridUtilitarios.CrearConfiguracionColumnaEdicion("NumeroFila", true);
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(configuracionColumnaNumeroFila);

            EditingColumnSetting configuracionColumnaCantidadMaxima = WebDataGridUtilitarios.CrearConfiguracionColumnaEdicion("Nombre", false);
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(configuracionColumnaCantidadMaxima);

            EditingColumnSetting configuracionColumnaCantidadMinima = WebDataGridUtilitarios.CrearConfiguracionColumnaEdicion("Apellido", false);
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.CellEditing.ColumnSettings.Add(configuracionColumnaCantidadMinima);

            #endregion

            #region Creación Columnas de Agregar Nuevo

            RowAddingColumnSetting configuracionAgregarNumeroFila = new RowAddingColumnSetting();
            configuracionAgregarNumeroFila.ColumnKey = "NumeroFila";
            configuracionAgregarNumeroFila.ReadOnly = true;
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(configuracionAgregarNumeroFila);

            RowAddingColumnSetting configuracionAgregarCantidadMaxima = new RowAddingColumnSetting();
            configuracionAgregarCantidadMaxima.ColumnKey = "Nombre";
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(configuracionAgregarCantidadMaxima);

            RowAddingColumnSetting configuracionAgregarCantidadMinima = new RowAddingColumnSetting();
            configuracionAgregarCantidadMinima.ColumnKey = "Apellido";
            wdgEspecificacionxFila.Behaviors.EditingCore.Behaviors.RowAdding.ColumnSettings.Add(configuracionAgregarCantidadMinima);

            #endregion
        }
        catch (Exception ex)
        {
           
        }
    }


}